#pragma once
//PlayPosition w BAJTACH!!!
//SETCONFIG!!!!!!!!!!!!!!!!!!!!!!!!!!

//#include <commctrl.h>
#include ".\common\aeffectx.h"
#include ".\common\aeffeditor.hpp"
#include "..\resource.h"
#include "waveengine.h"
#include <list>
using namespace std;

#define VST_LOAD		1
#define VST_ENUMERATE	0

typedef AEffect *(*PlugsMain)(audioMasterCallback cb);

struct Effect
{
	AEffect* pAEffect;
	HMODULE* phDll;
	HGLOBAL  hGlobal;
};

struct AllPluginsEntry
{
	char*	Name;
	char*	DllName;
};
	
class VSTPlugin
{
public:
	VSTPlugin(HINSTANCE hInstance, WaveEngine* pServer);
	~VSTPlugin();

	AEffect* Load(char*, BYTE Pos, bool flags, HMODULE* pEnumHandle);
	//EnumHandle zwracany niezerowy tylko wtedy, jesli flags = VST_ENUMERATE
	bool unLoad(BYTE num, AEffect* pUnEffect);

	bool isPluginReady(BYTE num);
	bool isSynth(AEffect* pEffect);

	void SetConfig(DWORD sRate, DWORD bSize, char* dir); // A must call!!
	bool EnumPlugins(void);
	void UpdateSamplePos(double pos);	// Should be called by a hosting class
										// from time to time ... ;)

	bool SetProgram( BYTE PlugNumber, int index);
	int	 GetCurrentProgram(BYTE PlugNumber);
	bool SetProgramName(BYTE PlugNumber, char* Name);
	bool GetProgramName(BYTE PlugNumber, char* Name); //[25]
	bool GetParamLabel(BYTE PlugNumber, int index, char* Label); //[9]
	bool GetParamDisplay(BYTE PlugNumber, int index, char* Display); //[?]
	bool GetParamName(BYTE PlugNumber, int index, char* Name); //[9];
	bool IsEmpty(void);

	bool GetDataBlock(char* Out, DWORD* sFilled, DWORD PlayPosition);
	char* GetPluginName(int pos);
	char* GetPluginDllName(int pos);

	//Windows Interfalce.
	void OpenPluginDialog(BYTE Num, BYTE NumInMenu);

protected:

	WaveEngine* DataServer;
	void Work(list<Effect*>::iterator i,float** fOut, DWORD PlayPosition);
	void BufferToFloat(char* In, float** Out, DWORD bSize);
	void BufferToShort(float** In, char* Out, DWORD bSize);
	float* fWorkBuffer[2];
	char* cWorkBuffer;
	DWORD sLastFilled;
	
	static DWORD SampleRate;
	static DWORD BlockSize;
	VstTimeInfo	TimeInfo;
	DWORD PlayPosition;

	list<Effect*> PluginChain;
	list<AllPluginsEntry> AllPluginNames;
		
	char VSTDir[MAX_PATH];
	static long VSTCALLBACK MasterCallback(AEffect *effect, long opcode, long index,
				 long value, void *ptr, float opt);
	long Dispatch(AEffect* pEffect, long opCode, long index, long value, void *ptr, float opt);

	//Windows Interface
//	WNDCLASS wc;
	HINSTANCE m_hInstance;
	//HGLOBAL hGlobal;		// Dialog Template memory
	//cos mi smierdzi bledem, ze to jest wspolne dla wsztskich i nigdy nie jest
	//delalokowane ... ?????
	WORD* Align2DWORD(WORD*);
	static HWND m_hWnd;
	static AEffect* m_pOpenEffect;
	static BOOL CALLBACK MainVSTDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	static BOOL CALLBACK MainVSTDlgProc2(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	static HFONT hFont;
};
